//////////////////////////////////////////////////////////////////////
// Simple Minesweeper clone by davr http://blog.davr.org/
// 
//////////////////////////////////////////////////////////////////////

//#define EMULATOR

#include <nds.h>
#include <stdlib.h>
//#include <nds/rand.h>
#include <nds/arm9/video.h>

#include <string.h>
#include <ctype.h>

//#include "../darkstar.h"

//#include "depack.h"

#include "font_raw.h"
#include "font_pal.h"

#include "tiles_raw.h"
#include "tiles_pal.h"

#include "title_raw.h"
#include "title_map.h"
#include "title_pal.h"


#define DEB
#define NODEB

void funky();



void
print(char *s)
{
#ifdef DEB

    // warning! will crash on hardware!
//    asm volatile ("mov r0, %0;" "swi 0xff0000;":        
  //                :"r" (s):"r0");

#endif    
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//
//
//

#ifdef EMULATOR

#define TOUCH_X (IPC->touchX / 14)
#define TOUCH_Y (IPC->touchY / 18 - 12)

#define TOUCH_2X (IPC->touchX / 7)
#define TOUCH_2Y (IPC->touchY / 9 - 24)

#endif

#define KEY_TOUCH (((~IPC->buttons) << 6) & (1<<12))

//header
#define TOUCH_CAL_X1 (*(vu16*)0x027FFCD8)
#define TOUCH_CAL_Y1 (*(vu16*)0x027FFCDA)
#define TOUCH_CAL_X2 (*(vu16*)0x027FFCDE)
#define TOUCH_CAL_Y2 (*(vu16*)0x027FFCE0)
#define max(x,y) ((x>y)?(x):(y))
#define min(x,y) ((x<y)?(x):(y))
static s32 TOUCH_WIDTH  = TOUCH_CAL_X2 - TOUCH_CAL_X1;
static s32 TOUCH_HEIGHT = TOUCH_CAL_Y2 - TOUCH_CAL_Y1;
static s32 TOUCH_OFFSET_X = ( ((SCREEN_WIDTH -60) * TOUCH_CAL_X1) / TOUCH_WIDTH  ) - 28;
static s32 TOUCH_OFFSET_Y = ( ((SCREEN_HEIGHT-60) * TOUCH_CAL_Y1) / TOUCH_HEIGHT ) - 28;
 
//code
//

void getTouch(s32 &x, s32 &y)
{
    x = IPC->touchXpx;
    y = IPC->touchYpx;
#if 0
#ifdef EMULATOR
    x = TOUCH_X;
    y = TOUCH_Y;
#else
    
    x = ( ((SCREEN_WIDTH -60) * IPC->touchX) / TOUCH_WIDTH  ) - TOUCH_OFFSET_X;
    y = ( ((SCREEN_HEIGHT-60) * IPC->touchY) / TOUCH_HEIGHT ) - TOUCH_OFFSET_Y;
    x = min(max(x, 0), SCREEN_WIDTH-1);
    y = min(max(y, 0), SCREEN_HEIGHT-1);
#endif
#endif
}

inline void COPY16(uint16* from, uint16* to,int size)
{
    uint8 *from8 = (uint8*)from;
    uint8 *to8 = (uint8*)to;
    for(int i=0;i<size*2;i+=2)
        to[i/2]=from8[i] + (from8[i+1] << 8);
}

int numFlags();
void drawTile(int x, int y, uint16* map);
void drawBoard(uint16* map);
void newBoard(int mines);
void reveal(int x, int y, uint16 *map);
void revealAll(uint16* map);
bool checkWin();

void writeChar(int x, int y, char c, uint16 *map)
{
    map[y*32 + x] = c - ' ';
}

void writeBChar(int x, int y, int c, uint16 *map)
{
    map[y*32 + x] = (c+1)*2;
    map[y*32 + x + 1] = (c+1)*2 + 1;
    map[(y+1)*32 + x] = (c+1)*2 + 32;
    map[(y+1)*32 + x + 1] = (c+1)*2 + 32 + 1;
}

void writeText(int x, int y, char *str, uint16 *map)
{
    for(int xp=0; xp<strlen(str); xp++)
    {
        int xx = x+xp;
        int yy = y;
        while(xx >= 32)
        {
            xx -= 32;
            yy++;
        }
        writeChar(xx, yy, toupper(str[xp]), map);
    }
}

#define WIDTH 16
#define HEIGHT 12

class tile
{
    public:
    int tile;
    bool mine;
    bool shown;
    bool flag;
};

tile board[WIDTH][HEIGHT];

void drawInstruct(uint16 *map)
{
  writeText(8,11, "Touch to reveal", map);
  writeText(7,13, "Don't touch mines", map);
  writeText(2,15, "Touch & drag to place a flag", map);
}

void drawMain(uint16 *map)
{
  writeText(10, 1, "Minesweeper", map);
  writeText(10, 2, "David Rorex", map);
}

void clearMap(uint16 *map)
{
    for(int y=0; y<32; y++)
    {
        for(int x=0; x<32; x++)
        {
            map[y*32 + x] = 0;
        }
    }
}       

void drawLose(uint16 *map)
{
    writeText(8,15, "BOOM - you loose",map);
    writeText(6,17, "Touch to play again",map);
}

void drawWin(uint16 *map)
{
    writeText(8,15, "YOU are a winner!",map);
    writeText(6,17, "Touch to play again",map);
}

void drawFound(uint16 *map, int numMines)
{
    char *numFound = "00 of 00 mines flagged";
    numFound[0] = numFlags()/10 + '0';
    numFound[1] = numFlags()%10 + '0';

    numFound[6] = numMines/10 + '0';
    numFound[7] = numMines%10 + '0';

    writeText(5, 5, numFound, map);
}



int main(int argc, char ** argv) {
    print("Lets go!");
    powerON(POWER_ALL);
    videoSetMode( MODE_0_2D | DISPLAY_SPR_1D_LAYOUT 
            | DISPLAY_SPR_ACTIVE | DISPLAY_BG0_ACTIVE | DISPLAY_BG1_ACTIVE );
    videoSetModeSub( MODE_0_2D | DISPLAY_SPR_1D_LAYOUT 
            | DISPLAY_SPR_ACTIVE | DISPLAY_BG0_ACTIVE | DISPLAY_BG1_ACTIVE );

    vramSetMainBanks(VRAM_A_MAIN_BG,VRAM_B_MAIN_SPRITE,VRAM_C_SUB_BG,VRAM_D_SUB_SPRITE);

#ifndef EMULATOR
    lcdSwap();
#endif 

    irqInit();
    irqSet(IRQ_VBLANK, NULL);
    irqEnable(IRQ_VBLANK);

    uint16* map0 = (uint16*)SCREEN_BASE_BLOCK(0);
    uint16* map1 = (uint16*)SCREEN_BASE_BLOCK_SUB(0);

    BG0_CR = BG_COLOR_16| BG_32x32 | (0 << SCREEN_SHIFT) | (1 << CHAR_SHIFT);
    SUB_BG0_CR = BG_COLOR_256 | BG_32x32 | (0 << SCREEN_SHIFT) | (1 << CHAR_SHIFT);

    COPY16((uint16*)title_pal, (uint16 *)BG_PALETTE_SUB, 256);
    COPY16((uint16*)title_map, map1, 256*192/2);
    //aP_depack((void *)title_raw, (void *)CHAR_BASE_BLOCK_SUB(1));
    COPY16((uint16*)title_raw, (uint16 *)CHAR_BASE_BLOCK_SUB(1), 25024/2);

    COPY16((uint16*)font_raw, (uint16 *)CHAR_BASE_BLOCK(1), 1536);
    COPY16((uint16*)font_pal, (uint16 *)BG_PALETTE, 16);
    BG_PALETTE[0] = RGB15(0,0,16);

  writeText( 8,10, "Touch to Start", map0);

  while(!KEY_TOUCH)
  {

      rand();
  }

  while(KEY_TOUCH)
      rand();

    BG0_CR = BG_COLOR_256| BG_32x32 | (0 << SCREEN_SHIFT) | (1 << CHAR_SHIFT);
    SUB_BG0_CR = BG_COLOR_16| BG_32x32  | (0 << SCREEN_SHIFT) | (1 << CHAR_SHIFT);

    // load in gfx & palettes
    COPY16((uint16*)font_raw, (uint16 *)CHAR_BASE_BLOCK_SUB(1), 1536);
    COPY16((uint16*)font_pal, (uint16 *)BG_PALETTE_SUB, 16);

    COPY16((uint16*)tiles_pal, (uint16 *)BG_PALETTE, 256);
    //aP_depack((void *)tiles_raw, (void *)CHAR_BASE_BLOCK(1));

    COPY16((uint16*)tiles_raw, (uint16 *)CHAR_BASE_BLOCK(1), 16384/2);

    //set background color
    BG_PALETTE[0] = RGB15(0,0,16);
    BG_PALETTE_SUB[0] = RGB15(0,16,0);
   
   
    // clear maps to blank them out
   for(int i=0; i< 1024; i++)
   {
       map0[i] = 0;
       map1[i] = 0;
   }


   drawMain(map1);
      
  clearMap(map1);
  drawMain(map1);
  drawInstruct(map1);


  int numMines = 10;

  newBoard(numMines);

  drawBoard(map0);
    
  int touched = 0;
  int tx = 0;
  int ty = 0;
  int tx2 = 0;
  int ty2 = 0;


  drawFound(map1, numMines);

  while (1) {
      scanKeys();
//      swiWaitForVBlank();
      if(KEY_TOUCH)
      {
#ifndef EMULATOR
          s32 TOUCH_X, TOUCH_Y;
          getTouch(TOUCH_X, TOUCH_Y);
#endif
          if(touched == 0)
          {
              print("Touched");
            touched = 1;
            tx = tx2 = TOUCH_X/16 ;
            ty = ty2 = TOUCH_Y/16 ;
          }
          if((TOUCH_X) != 0 && (TOUCH_Y) != 0)
          {
              tx2 = TOUCH_X/16 ;
              ty2 = TOUCH_Y/16 ;
          }
#ifdef DEB        
              char buf[10];
              buf[0] = ((TOUCH_X)/100) + '0';
              buf[1] = ((TOUCH_X)/10)%10 + '0';
              buf[2] = (TOUCH_X)%10 + '0';
              buf[3] = ',';
              buf[4] = ((TOUCH_Y)/100) + '0';
              buf[5] = ((TOUCH_Y)/10)%10 + '0';
              buf[6] = (TOUCH_Y)%10 + '0';
              buf[7] = '\0'; 
#ifdef NODEB
              for(int q=0; q<7; q++) buf[q] = ' ';
#endif
              writeText(0,3,buf,map1);
#endif              

     }
      else
      {
          if(touched == 1)
          {
              touched = 0;
#ifdef DEB              
              char buf[10];
              buf[0] = tx/10 + '0';
              buf[1] = tx%10 + '0';
              buf[2] = ',';
              buf[3] = ty/10 + '0';
              buf[4] = ty%10 + '0';
              buf[5] = '\0';
#ifdef NODEB
              for(int q=0; q<5; q++) buf[q] = ' ';
#endif
              writeText(0,0,buf,map1);
              buf[0] = tx2/10 + '0';
              buf[1] = tx2%10 + '0';
              buf[2] = ',';
              buf[3] = ty2/10 + '0';
              buf[4] = ty2%10 + '0';
              buf[5] = '\0';
#ifdef NODEB
              for(int q=0; q<5; q++) buf[q] = ' ';
#endif
              writeText(0,1,buf,map1);
#endif              
              if(tx == tx2 && ty == ty2)
              {
                  if(board[tx][ty].flag == false)
                  {
                      reveal(tx, ty, map0);

                      if(board[tx][ty].mine)
                      {
                          clearMap(map1);
                          drawLose(map1);
                          revealAll(map0);
                          while(KEY_TOUCH) ;
                          while(!KEY_TOUCH) ;
                          while(KEY_TOUCH) ;
                          clearMap(map1);
                          drawMain(map1);
                          drawInstruct(map1);
                          newBoard(numMines);
                          drawBoard(map0);
                      }
                  }
              }
              else
              {
                  if(!board[tx][ty].shown)
                  {
                      board[tx][ty].flag = !board[tx][ty].flag;
                  }
                  else
                  {
                      board[tx][ty].shown = false;
                      board[tx][ty].flag = true;
                  }
                  drawTile(tx, ty, map0);
              }

              if(checkWin())
              {
                  clearMap(map1);
                  drawWin(map1);
                  revealAll(map0);
                  while(KEY_TOUCH) ;
                  while(!KEY_TOUCH) ;
                  while(KEY_TOUCH) ;
                  clearMap(map1);
                  drawMain(map1);
                  drawInstruct(map1);
                  numMines += 5;
                  newBoard(numMines);
                  drawBoard(map0);
              }

              
            drawFound(map1, numMines);
              

          }
      }

  }
  return 0;
}

int numFlags()
{
    int flags=0;
    for(int x=0; x<WIDTH; x++)
    {
        for(int y=0; y<HEIGHT; y++)
        {
            if(board[x][y].flag)
                flags++;
        }
    }
    return flags;
}
            


void reveal(int x, int y, uint16 *map)
{
    if(x < 0 || x >= WIDTH || y<0 || y>=HEIGHT || board[x][y].shown || board[x][y].flag)
        return;
    board[x][y].shown = true;
    drawTile(x,y, map);
    if(board[x][y].tile == 0)
    {
        reveal(x-1,y-1, map);
        reveal(x,y-1, map);
        reveal(x+1,y-1, map);
        reveal(x-1,y, map);

        reveal(x+1,y, map);
        reveal(x-1,y+1, map);
        reveal(x,y+1, map);
        reveal(x+1,y+1, map);
    }
}

bool checkWin()
{
    bool flaggedAll=true;
    bool revealedAll=true;
    for(int x=0; x<WIDTH; x++)
    {
        for(int y=0; y<HEIGHT; y++)
        {
            if(board[x][y].mine && !board[x][y].flag)
                flaggedAll=false;
            if(!board[x][y].mine && board[x][y].flag)
                flaggedAll=false;
            if(!board[x][y].mine && !board[x][y].shown)
                revealedAll=false;
        }
    }

    return flaggedAll | revealedAll;
}
    

   
    

void newBoard(int mines)
{
    for(int x=0; x<WIDTH; x++)
    {
        for(int y=0; y<HEIGHT; y++)
        {
            board[x][y].tile = 0;
            board[x][y].mine = false;
            board[x][y].flag = false;
            board[x][y].shown = false;
        }
    }
    for(int m=0; m<mines; m++)
    {
        int x = rand()%WIDTH;
        int y = rand()%HEIGHT;
        if(board[x][y].mine)
        {
            m--;
        }
        else
        {
            board[x][y].mine = true;
        }
    }
    for(int x=0; x<WIDTH; x++)
    {
        for(int y=0; y<HEIGHT; y++)
        {
                int m = 0;
                if(x > 0 && y > 0 && board[x-1][y-1].mine) m++;
                if(y > 0 && board[x  ][y-1].mine) m++;
                if(x < WIDTH-1 && y > 0 && board[x+1][y-1].mine) m++;
                if(x > 0 && board[x-1][y].mine) m++;

                if(x < WIDTH-1 && board[x+1][y].mine) m++;
                if(x > 0 && y < HEIGHT-1 && board[x-1][y+1].mine) m++;
                if(y < HEIGHT-1 && board[x  ][y+1].mine) m++;
                if(x < WIDTH-1 && y < HEIGHT-1 && board[x+1][y+1].mine) m++;

                board[x][y].tile = m;
        }
    }
}

void drawTile(int x, int y, uint16* map)
{
    int c;
    if(board[x][y].flag)
        c = 11;
    else if(!board[x][y].shown)
        c = 10;
    else if(board[x][y].mine)
        c = 12;
    else
        c = board[x][y].tile;
    writeBChar(x*2, y*2, c, map);
}
    
void revealAll(uint16* map)
{
    for(int x=0; x<WIDTH; x++)
    {
        for(int y=0; y<HEIGHT; y++)
        {
            board[x][y].shown = true;
        }
    }
    drawBoard(map);
}


void drawBoard(uint16* map)
{
    for(int x=0; x<WIDTH; x++)
    {
        for(int y=0; y<HEIGHT; y++)
        {
                drawTile(x, y, map);
        }
    }
}


//////////////////////////////////////////////////////////////////////
